<?php


namespace Repositories;


use Doctrine\ORM\EntityManager;
use Util\InstanceProvider;
use Teknisa\Model\Traits\TQuery;

class Notice
{
    use TQuery;
    /**
     * @var EntityManager
     */
    private $entityManager;

    /**
     * Notice constructor.
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function getNoticesLogin($nrorg)
    {
        $query = <<<SQL
        SELECT DSTITULOINF, TXCONTEUDOINF, IDNOTIFICACAO, DTEXPIRAINFO, DTINFORMARIVI, IDATIVO,
        NRINFECOMMERCE, CDPUBLICOALVO, MARKISREAD
        FROM INFORMATIVOECOMMERCE
          WHERE CDPUBLICOALVO = 'L'
          AND IDATIVO = 'S'
          AND TRUNC(SYSDATE) BETWEEN TRUNC(DTINFORMARIVI) AND TRUNC(DTEXPIRAINFO)
          AND NRORG = :NRORG
SQL;

        $params = array(
            'NRORG' => $nrorg,
        );

        $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrorg);
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();
        return $entityManager->getConnection()->fetchAll($query, $params);
    }

    public function getTimeOutNoticesLogin($nrorg)
    {
        $query = <<<SQL
        SELECT ID, DSNOME, QTDIAS, CDPUBLICOALVO, IDATIVO
        FROM INFORMATIVOECOMSILE
          WHERE CDPUBLICOALVO = 'LOGIN'
          AND IDATIVO = 'S'
          AND NRORG = :NRORG
SQL;

        $params = array(
            'NRORG' => $nrorg,
        );

        $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrorg);
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();
        return $entityManager->getConnection()->fetchAll($query, $params);
    }

    public function getDtInforEcomOper($cdOperador, $nrorg, $cdPublicoAlvo = 'LOGIN')
    {
        $query =
            <<<SQL
                SELECT TO_CHAR(DTINFOSILE, 'DD/MM/YYYY') || ' 23:59:59' AS DTINFOSILE 
                  FROM INFORMATIVOECOMSILEOPER
                 WHERE CDPUBLICOALVO = :CDPUBLICOALVO
                   AND CDOPERADOR = :CDOPERADOR
                   AND NRORG = :NRORG

SQL;
        $params = array(
            'CDOPERADOR'    => $cdOperador,
            'NRORG'         => $nrorg,
            'CDPUBLICOALVO' => $cdPublicoAlvo,
        );

        $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrorg);
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();
        return $entityManager->getConnection()->fetchAll($query, $params);
    }

    public function getNoticesMarkIsRead($cdOperador, $nrorg)
    {
        $query =
            <<<SQL
                SELECT NRINFECOMMERCE 
                  FROM INFORMATIVOECOMOPER
                 WHERE CDOPERADOR = :CDOPERADOR
                   AND NRORG = :NRORG

SQL;
        $params = array(
            'CDOPERADOR' => $cdOperador,
            'NRORG'     => $nrorg
        );

        $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrorg);
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();
        return $entityManager->getConnection()->fetchAll($query, $params);
    }
}
