/* Retorna o cdigo reduzido da conta contbil do produto */
CREATE OR REPLACE FUNCTION USR_CONTCTBL_PROD
   (P_CDFILIAL   IN NOTAFISCAL.CDFILIAL%TYPE,
    P_NRLANCTONF IN NOTAFISCAL.NRLANCTONF%TYPE,
    P_CDPRODUTO  IN PRODUTO.CDPRODUTO%TYPE,
    P_CDARVPROD  IN PRODUTO.CDARVPROD%TYPE)
RETURN VARCHAR
AS
   V_IDENTRSAIDOP VARCHAR2(01);
   V_CDTIPOOPER   VARCHAR2(02);
   V_CDFILIAL     VARCHAR2(04);
   V_CDCONTCTBL   VARCHAR2(20);
   V_CDCONTREDU   VARCHAR2(20);
   V_CDARVPROD    VARCHAR2(20);
BEGIN
   SELECT MAX(IDENTRSAIDOP), MAX(CDTIPOOPER),
          MAX(DECODE(IDENTRSAIDOP, 'E', CDFILIRECE, CDFILIEMIT))
   INTO V_IDENTRSAIDOP, V_CDTIPOOPER, V_CDFILIAL
   FROM NOTAFISCAL
   WHERE CDFILIAL   = P_CDFILIAL AND
         NRLANCTONF = P_NRLANCTONF;

   SELECT MAX(CDCONTPROD)
   INTO V_CDCONTCTBL
   FROM TIPOOPERAC
   WHERE IDENTRSAIDOP = V_IDENTRSAIDOP AND
         CDTIPOOPER   = V_CDTIPOOPER;

   IF V_CDCONTCTBL IS NULL THEN
      SELECT MAX(DECODE(V_IDENTRSAIDOP, 'E', CDCTBLENTRPF, CDCTBLSAIDPF))
      INTO V_CDCONTCTBL
      FROM PRODFILI
      WHERE CDFILIAL  = V_CDFILIAL AND
            CDPRODUTO = P_CDPRODUTO;

      IF V_CDCONTCTBL IS NULL THEN
         SELECT MAX(CDARVPROD)
         INTO V_CDARVPROD
         FROM PRODUTO
         WHERE P_CDARVPROD LIKE CDARVPROD || '%' AND
               DECODE(V_IDENTRSAIDOP, 'E', CDCTBLENTRPR, CDCTBLSAIDPR) IS NOT NULL;

         SELECT MAX(DECODE(V_IDENTRSAIDOP, 'E', CDCTBLENTRPR, CDCTBLSAIDPR))
         INTO V_CDCONTCTBL
         FROM PRODUTO
         WHERE CDARVPROD = V_CDARVPROD;
      END IF;
   END IF;

   SELECT MAX(CDCONTREDU)
   INTO V_CDCONTREDU
   FROM CONTCTBL
   WHERE CDCONTCTBL = V_CDCONTCTBL;

   IF V_CDCONTREDU IS NULL THEN
      RETURN(V_CDCONTCTBL);
   ELSE
      RETURN(V_CDCONTREDU);
   END IF;
END;
/

/* Retorna o cdigo reduzido da conta contbil do imposto */
CREATE OR REPLACE FUNCTION USR_CONTCTBL_IMPOSTO
    (P_CDFILIAL   IN NOTAFISCAL.CDFILIAL%TYPE,
    P_NRLANCTONF IN NOTAFISCAL.NRLANCTONF%TYPE,
    P_CDIMPOSTO  IN IMPOSTO.CDIMPOSTO%TYPE)
RETURN VARCHAR
AS
   V_IDENTRSAIDOP VARCHAR2(01);
   V_CDTIPOOPER   VARCHAR2(02);
   V_CDCONTCTBL   VARCHAR2(20);
   V_CDCONTREDU   VARCHAR2(20);
BEGIN
   SELECT MAX(IDENTRSAIDOP), MAX(CDTIPOOPER)
   INTO V_IDENTRSAIDOP, V_CDTIPOOPER
   FROM NOTAFISCAL
   WHERE CDFILIAL   = P_CDFILIAL AND
         NRLANCTONF = P_NRLANCTONF;

   SELECT MAX(DECODE(V_IDENTRSAIDOP, 'E', CDCCTBATIVTO, CDCCTBPASSTO))
   INTO V_CDCONTCTBL
   FROM CTBIMPTPOPER
   WHERE IDENTRSAIDOP = V_IDENTRSAIDOP AND
         CDTIPOOPER   = V_CDTIPOOPER   AND
         CDIMPOSTO    = P_CDIMPOSTO;

   IF V_CDCONTCTBL IS NULL THEN
      SELECT MAX(DECODE(V_IDENTRSAIDOP, 'E', CDCCTBLATIV, CDCCTBLPASS))
      INTO V_CDCONTCTBL
      FROM IMPOSTO
      WHERE CDIMPOSTO    = P_CDIMPOSTO;
   END IF;

   SELECT MAX(CDCONTREDU)
   INTO V_CDCONTREDU
   FROM CONTCTBL
   WHERE CDCONTCTBL = V_CDCONTCTBL;

   IF V_CDCONTREDU IS NULL THEN
      RETURN(V_CDCONTCTBL);
   ELSE
      RETURN(V_CDCONTREDU);
   END IF;
END;
/

/* Retorna o cdigo reduzido da conta contbil do encargo da nota fiscal */
CREATE OR REPLACE FUNCTION USR_CONTCTBL_ENCARGO
   (P_CDFILIAL   IN NOTAFISCAL.CDFILIAL%TYPE,
    P_NRLANCTONF IN NOTAFISCAL.NRLANCTONF%TYPE,
    P_CDENCARGO  IN IMPOSTO.CDIMPOSTO%TYPE)
RETURN VARCHAR
AS
   V_IDENTRSAIDOP VARCHAR2(01);
   V_CDCONTCTBL   VARCHAR2(20);
   V_CDCONTREDU   VARCHAR2(20);
BEGIN
   SELECT MAX(IDENTRSAIDOP)
   INTO V_IDENTRSAIDOP
   FROM NOTAFISCAL
   WHERE CDFILIAL   = P_CDFILIAL AND
         NRLANCTONF = P_NRLANCTONF;

   SELECT MAX(DECODE(V_IDENTRSAIDOP, 'E', CDCTBLENTREN, CDCTBLSAIDEN))
   INTO V_CDCONTCTBL
   FROM ENCARGO
   WHERE CDENCARGO = P_CDENCARGO;

   SELECT MAX(CDCONTREDU)
   INTO V_CDCONTREDU
   FROM CONTCTBL
   WHERE CDCONTCTBL = V_CDCONTCTBL;

   IF V_CDCONTREDU IS NULL THEN
      RETURN(V_CDCONTCTBL);
   ELSE
      RETURN(V_CDCONTREDU);
   END IF;
END;
/

/* Retorna a descrio dos dados adicionais */
CREATE OR REPLACE FUNCTION USR_DADOS_ADIC
   (P_CDFILIAL   IN NOTAFISCAL.CDFILIAL%TYPE,
    P_NRLANCTONF IN NOTAFISCAL.NRLANCTONF%TYPE)
RETURN VARCHAR
AS
   V_AUXILIAR VARCHAR2(2000);
BEGIN
   V_AUXILIAR := 'X';
   FOR C_DADOSADIC IN (SELECT DSDADOADIC
                       FROM DADOSADIC
                       WHERE CDFILIAL   = P_CDFILIAL   AND
                             NRLANCTONF = P_NRLANCTONF
                       ORDER BY NRDADOADIC) LOOP
      IF V_AUXILIAR = 'X' THEN
         V_AUXILIAR := C_DADOSADIC.DSDADOADIC;
      ELSE
         V_AUXILIAR := V_AUXILIAR || ' ' || C_DADOSADIC.DSDADOADIC;
      END IF;
   END LOOP;
   RETURN(SUBSTR(V_AUXILIAR,1,20));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_CONTCTBL_IMPOSTO','5.09.000'); END;
/

